function d_matrix=dEuler(alpha,beta,gamma)
%this function returns the Euler matrix for rotating a 2nd rank tensor between different coordinate systems.
%accepts 3 angles which relates two coordinate systems.

% Kresten Bertelsen September 2010 
a=alpha;
b=beta;
g=gamma;

ang = [     exp(i.*2.*a).*  exp(i.*2.*g), exp(i.*2.*a).*  exp(i.*g), exp(i.*2.*a).* 1, exp(i.*2.*a).*  exp(-i.*g),      exp(i.*2.*a).*  exp(-i.*2.*g);...
            exp(i.*a).*     exp(i.*2.*g), exp(i.*a).*     exp(i.*g), exp(i.*a).*    1, exp(i.*a).*     exp(-i.*g),      exp(i.*a).*     exp(-i.*2.*g);...
            1.*             exp(i.*2.*g), 1.*             exp(i.*g), 1.*            1, 1.*             exp(-i.*g),      1.*             exp(-i.*2.*g);...
            exp(-i.*a).*    exp(i.*2.*g), exp(-i.*a).*    exp(i.*g), exp(-i.*a).*   1, exp(-i.*a).*    exp(-i.*g),      exp(-i.*a).*    exp(-i.*2.*g);...
            exp(-i.*2.*a).* exp(i.*2.*g), exp(-i.*2.*a).* exp(i.*g), exp(-i.*2.*a).*1, exp(-i.*2.*a).* exp(-i.*g),      exp(-i.*2.*a).* exp(-i.*2.*g)];   
            
            
d_mat=[	    1./4.*(1+cos(b)).^2,		   -1./2.*(1+cos(b)).*sin(b)    ,   sqrt(3./8).*sin(b).^2 , -1./2.*(1-cos(b)).*sin(b)     ,   1./4.*(1-cos(b)).^2      ;
		    1./2.*(1+cos(b)).*sin(b),       (cos(b).^2-1./2.*(1-cos(b))),   -sqrt(3./8).*sin(2.*b) , (1./2.*(1+cos(b))-cos(b).^2) ,   -1./2.*(1-cos(b)).*sin(b) ;
		    sqrt(3./8).*sin(b).^2,           sqrt(3./8).*sin(2.*b)      ,   1./2.*(3.*cos(b).^2-1), -sqrt(3./8).*sin(2.*b)        ,   sqrt(3./8).*sin(b).^2    ;
		    1./2.*(1-cos(b)).*sin(b),       (1./2.*(1+cos(b))-cos(b).^2),   sqrt(3./8).*sin(2.*b), (cos(b).^2-1./2.*(1-cos(b)))   ,   -1./2.*(1+cos(b)).*sin(b) ;
		    1./4.*(1-cos(b)).^2,             1./2.*(1-cos(b)).*sin(b)   ,   sqrt(3./8).*sin(b).^2, 1./2.*(1+cos(b)).*sin(b)       ,   1./4.*(1+cos(b)).^2      ];
       
            d_matrix=ang.*d_mat;
end